
#ifndef _USER_LIBC_H_
#define _USER_LIBC_H_

#include <types.h>

/**
 * @file libc.h
 *
 * The basic user C library for user programs
 */

/**
 * The most important function of a C program ! ;)
 */
void exit (int status);

/**
 * Function to duplicate the current running process
 */
int fork();

int waitpid(int pid, int *status);

unsigned int strlen(register const char *str);

int read(int fd, char * buf, size_t len);
int write(int fd, const char * buf, size_t len);

int close(int fd);

#endif /* _USER_LIBC_H_ */
